import type { DefaultSharedModuleContext, LangiumServices, LangiumSharedServices, Module, PartialLangiumServices } from 'langium';
import { createDefaultModule, createDefaultSharedModule, inject } from 'langium';
import { BassguitarGeneratedModule, BassguitarGeneratedSharedModule } from './generated/module.js';
import { BassguitarValidator, registerValidationChecks } from './bassguitar-validator.js';
import { CustomScopeComputation } from './bassguitar-scope.js';

/**
 * Declaration of custom services - add your own service classes here.
 */
export type BassguitarAddedServices = {
    validation: {
        BassguitarValidator: BassguitarValidator
    }
}

/**
 * Union of Langium default services and your custom services - use this as constructor parameter
 * of custom service classes.
 */
export type BassguitarServices = LangiumServices & BassguitarAddedServices

/**
 * Dependency injection module that overrides Langium default services and contributes the
 * declared custom services. The Langium defaults can be partially specified to override only
 * selected services, while the custom services must be fully specified.
 */
export const BassguitarModule: Module<BassguitarServices, PartialLangiumServices & BassguitarAddedServices> = {
    references:{
        ScopeComputation: (services) => new CustomScopeComputation(services)
    },
    validation: {
        BassguitarValidator: () => new BassguitarValidator()
    }
};

/**
 * Create the full set of services required by Langium.
 *
 * First inject the shared services by merging two modules:
 *  - Langium default shared services
 *  - Services generated by langium-cli
 *
 * Then inject the language-specific services by merging three modules:
 *  - Langium default language-specific services
 *  - Services generated by langium-cli
 *  - Services specified in this file
 *
 * @param context Optional module context with the LSP connection
 * @returns An object wrapping the shared services and the language-specific services
 */
export function createBassguitarServices(context: DefaultSharedModuleContext): {
    shared: LangiumSharedServices,
    Bassguitar: BassguitarServices
} {
    const shared = inject(
        createDefaultSharedModule(context),
        BassguitarGeneratedSharedModule
    );
    const Bassguitar = inject(
        createDefaultModule({ shared }),
        BassguitarGeneratedModule,
        BassguitarModule
    );
    shared.ServiceRegistry.register(Bassguitar);
    registerValidationChecks(Bassguitar);
    return { shared, Bassguitar };
}
